Index: uspace/lib/hound/include/hound/protocol.h
===================================================================
--- uspace/lib/hound/include/hound/protocol.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/hound/include/hound/protocol.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -58,19 +58,9 @@
 typedef intptr_t hound_context_id_t;
 
-/**
- * Check context id for errors.
- * @param id Context id
- * @return Error code.
- */
-static inline int hound_context_id_err(hound_context_id_t id)
-{
-	return id > 0 ? EOK : (id == 0 ? ENOENT : id);
-}
-
 hound_sess_t *hound_service_connect(const char *service);
 void hound_service_disconnect(hound_sess_t *sess);
 
-hound_context_id_t hound_service_register_context(hound_sess_t *sess,
-    const char *name, bool record);
+int hound_service_register_context(hound_sess_t *sess,
+    const char *name, bool record, hound_context_id_t *id);
 int hound_service_unregister_context(hound_sess_t *sess, hound_context_id_t id);
 
Index: uspace/lib/hound/src/client.c
===================================================================
--- uspace/lib/hound/src/client.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/hound/src/client.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -123,7 +123,8 @@
 			return NULL;
 		}
-		new_context->id = hound_service_register_context(
-		    new_context->session, new_context->name, record);
-		if (hound_context_id_err(new_context->id) != EOK) {
+		int rc = hound_service_register_context(
+		    new_context->session, new_context->name, record,
+		    &new_context->id);
+		if (rc != EOK) {
 			hound_service_disconnect(new_context->session);
 			free(new_context->name);
Index: uspace/lib/hound/src/protocol.c
===================================================================
--- uspace/lib/hound/src/protocol.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/hound/src/protocol.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -115,8 +115,11 @@
  * @param name Valid string identifier
  * @param record True if the application context wishes to receive data.
- * @return Valid ID on success, Error code on failure.
- */
-hound_context_id_t hound_service_register_context(hound_sess_t *sess,
-    const char *name, bool record)
+ *
+ * @param[out] id  Return context ID.
+ *
+ * @return EOK on success, Error code on failure.
+ */
+int hound_service_register_context(hound_sess_t *sess,
+    const char *name, bool record, hound_context_id_t *id)
 {
 	assert(sess);
@@ -126,5 +129,5 @@
 	aid_t mid =
 	    async_send_1(exch, IPC_M_HOUND_CONTEXT_REGISTER, record, &call);
-	int ret = mid ? EOK : EPARTY;
+	sysarg_t ret = mid ? EOK : EPARTY;
 
 	if (ret == EOK)
@@ -134,8 +137,12 @@
 
 	if (ret == EOK)
-		async_wait_for(mid, (sysarg_t *)&ret);
+		async_wait_for(mid, &ret);
 
 	async_exchange_end(exch);
-	return ret == EOK ? (hound_context_id_t)IPC_GET_ARG1(call) : ret;
+	if (ret == EOK) {
+		*id = (hound_context_id_t)IPC_GET_ARG1(call);
+	}
+
+	return ret;
 }
 
@@ -182,7 +189,7 @@
 	ipc_call_t res_call;
 	aid_t mid = async_send_3(exch, IPC_M_HOUND_GET_LIST, flags, *count,
-	    (bool)connection, &res_call);
-
-	int ret = EOK;
+	    connection != NULL, &res_call);
+
+	sysarg_t ret = EOK;
 	if (mid && connection)
 		ret = async_data_write_start(exch, connection,
@@ -190,5 +197,5 @@
 
 	if (ret == EOK)
-		async_wait_for(mid, (sysarg_t*)&ret);
+		async_wait_for(mid, &ret);
 
 	if (ret != EOK) {
@@ -252,10 +259,10 @@
 	ipc_call_t call;
 	aid_t id = async_send_0(exch, IPC_M_HOUND_CONNECT, &call);
-	int ret = id ? EOK : EPARTY;
+	sysarg_t ret = id ? EOK : EPARTY;
 	if (ret == EOK)
 		ret = async_data_write_start(exch, source, str_size(source));
 	if (ret == EOK)
 		ret = async_data_write_start(exch, sink, str_size(sink));
-	async_wait_for(id, (sysarg_t*)&ret);
+	async_wait_for(id, &ret);
 	async_exchange_end(exch);
 	return ret;
@@ -278,10 +285,10 @@
 	ipc_call_t call;
 	aid_t id = async_send_0(exch, IPC_M_HOUND_DISCONNECT, &call);
-	int ret = id ? EOK : EPARTY;
+	sysarg_t ret = id ? EOK : EPARTY;
 	if (ret == EOK)
 		ret = async_data_write_start(exch, source, str_size(source));
 	if (ret == EOK)
 		ret = async_data_write_start(exch, sink, str_size(sink));
-	async_wait_for(id, (sysarg_t*)&ret);
+	async_wait_for(id, &ret);
 	async_exchange_end(exch);
 	return ENOTSUP;
Index: uspace/lib/http/include/http/receive-buffer.h
===================================================================
--- uspace/lib/http/include/http/receive-buffer.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/http/include/http/receive-buffer.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -46,7 +46,8 @@
  * @param buf buffer to store the data
  * @param buf_size buffer size
- * @return number of bytes received or negative error code
+ * @param nrecv number of bytes actually received
+ * @return EOK on success or error code
  */
-typedef ssize_t (*receive_func_t)(void *, void *, size_t);
+typedef int (*receive_func_t)(void *, void *, size_t, size_t *);
 
 typedef struct {
@@ -81,10 +82,10 @@
     receive_buffer_mark_t *, char **);
 extern int recv_char(receive_buffer_t *, char *, bool);
-extern ssize_t recv_buffer(receive_buffer_t *, char *, size_t);
-extern ssize_t recv_discard(receive_buffer_t *, char);
-extern ssize_t recv_discard_str(receive_buffer_t *, const char *);
-extern ssize_t recv_while(receive_buffer_t *, char_class_func_t);
-extern ssize_t recv_eol(receive_buffer_t *);
-extern ssize_t recv_line(receive_buffer_t *, char *, size_t);
+extern int recv_buffer(receive_buffer_t *, char *, size_t, size_t *);
+extern int recv_discard(receive_buffer_t *, char, size_t *);
+extern int recv_discard_str(receive_buffer_t *, const char *, size_t *);
+extern int recv_while(receive_buffer_t *, char_class_func_t);
+extern int recv_eol(receive_buffer_t *, size_t *);
+extern int recv_line(receive_buffer_t *, char *, size_t, size_t *);
 
 #endif
Index: uspace/lib/http/src/headers.c
===================================================================
--- uspace/lib/http/src/headers.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/http/src/headers.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -146,6 +146,7 @@
 			continue;
 		
-		rc = recv_discard(rb, (c == '\r' ? '\n' : '\r'));
-		if (rc < 0)
+		size_t nrecv;
+		rc = recv_discard(rb, (c == '\r' ? '\n' : '\r'), &nrecv);
+		if (rc != EOK)
 			return rc;
 		
Index: uspace/lib/http/src/http.c
===================================================================
--- uspace/lib/http/src/http.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/http/src/http.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -47,15 +47,10 @@
 #include <http/receive-buffer.h>
 
-static ssize_t http_receive(void *client_data, void *buf, size_t buf_size)
+static int http_receive(void *client_data, void *buf, size_t buf_size,
+    size_t *nrecv)
 {
 	http_t *http = client_data;
-	size_t nrecv;
-	int rc;
 
-	rc = tcp_conn_recv_wait(http->conn, buf, buf_size, &nrecv);
-	if (rc != EOK)
-		return rc;
-
-	return nrecv;
+	return tcp_conn_recv_wait(http->conn, buf, buf_size, nrecv);
 }
 
Index: uspace/lib/http/src/receive-buffer.c
===================================================================
--- uspace/lib/http/src/receive-buffer.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/http/src/receive-buffer.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -61,7 +61,9 @@
 }
 
-static ssize_t dummy_receive(void *unused, void *buf, size_t buf_size)
-{
-	return 0;
+static int dummy_receive(void *unused, void *buf, size_t buf_size,
+    size_t *nrecv)
+{
+	*nrecv = 0;
+	return EOK;
 }
 
@@ -167,9 +169,10 @@
 		}
 		
-		ssize_t rc = rb->receive(rb->client_data, rb->buffer + rb->in, free);
-		if (rc <= 0)
+		size_t nrecv;
+		int rc = rb->receive(rb->client_data, rb->buffer + rb->in, free, &nrecv);
+		if (rc != EOK)
 			return rc;
 		
-		rb->in = rc;
+		rb->in = nrecv;
 	}
 	
@@ -180,21 +183,24 @@
 }
 
-ssize_t recv_buffer(receive_buffer_t *rb, char *buf, size_t buf_size)
-{
-	/* Flush any buffered data*/
+int recv_buffer(receive_buffer_t *rb, char *buf, size_t buf_size,
+    size_t *nrecv)
+{
+	/* Flush any buffered data */
 	if (rb->out != rb->in) {
 		size_t size = min(rb->in - rb->out, buf_size);
 		memcpy(buf, rb->buffer + rb->out, size);
 		rb->out += size;
-		return size;
-	}
-	
-	return rb->receive(rb->client_data, buf, buf_size);
+		*nrecv = size;
+		return EOK;
+	}
+	
+	return rb->receive(rb->client_data, buf, buf_size, nrecv);
 }
 
 /** Receive a character and if it is c, discard it from input buffer
- * @return number of characters discarded (0 or 1) or negative error code
- */
-ssize_t recv_discard(receive_buffer_t *rb, char discard)
+ * @param ndisc Place to store number of characters discarded
+ * @return EOK or error code
+ */
+int recv_discard(receive_buffer_t *rb, char discard, size_t *ndisc)
 {
 	char c = 0;
@@ -202,34 +208,39 @@
 	if (rc != EOK)
 		return rc;
-	if (c != discard)
-		return 0;
+	if (c != discard) {
+		*ndisc = 0;
+		return EOK;
+	}
 	rc = recv_char(rb, &c, true);
 	if (rc != EOK)
 		return rc;
-	return 1;
+	*ndisc = 1;
+	return EOK;
 }
 
 /** Receive a prefix of constant string discard and return number of bytes read
- * @return number of characters discarded or negative error code
- */
-ssize_t recv_discard_str(receive_buffer_t *rb, const char *discard)
+ * @param ndisc Place to store number of characters discarded
+ * @return EOK or error code
+ */
+int recv_discard_str(receive_buffer_t *rb, const char *discard, size_t *ndisc)
 {
 	size_t discarded = 0;
 	while (*discard) {
-		ssize_t rc = recv_discard(rb, *discard);
-		if (rc < 0)
-			return rc;
-		if (rc == 0)
+		size_t nd;
+		int rc = recv_discard(rb, *discard, &nd);
+		if (rc != EOK)
+			return rc;
+		if (nd == 0)
 			break;
-		discarded++;
+		discarded += nd;
 		discard++;
 	}
-	return discarded;
-}
-
-ssize_t recv_while(receive_buffer_t *rb, char_class_func_t class)
-{
-	size_t received = 0;
-	
+
+	*ndisc = discarded;
+	return EOK;
+}
+
+int recv_while(receive_buffer_t *rb, char_class_func_t class)
+{
 	while (true) {
 		char c = 0;
@@ -244,17 +255,16 @@
 		if (rc != EOK)
 			return rc;
-		
-		received++;
-	}
-	
-	return received;
+	}
+	
+	return EOK;
 }
 
 /** Receive an end of line, either CR, LF, CRLF or LFCR
  *
- * @return number of bytes read (0 if no newline is present in the stream)
- *         or negative error code
- */
-ssize_t recv_eol(receive_buffer_t *rb)
+ * @param nrecv Place to store number of bytes received (zero if
+ *              no newline is present in the stream)
+ * @return EOK on success or error code
+ */
+int recv_eol(receive_buffer_t *rb, size_t *nrecv)
 {
 	char c = 0;
@@ -263,6 +273,8 @@
 		return rc;
 	
-	if (c != '\r' && c != '\n')
-		return 0;
+	if (c != '\r' && c != '\n') {
+		*nrecv = 0;
+		return EOK;
+	}
 	
 	rc = recv_char(rb, &c, true);
@@ -270,15 +282,18 @@
 		return rc;
 	
-	ssize_t rc2 = recv_discard(rb, (c == '\r' ? '\n' : '\r'));
-	if (rc2 < 0)
-		return rc2;
-	
-	return 1 + rc2;
+	size_t nr;
+	rc = recv_discard(rb, (c == '\r' ? '\n' : '\r'), &nr);
+	if (rc != EOK)
+		return rc;
+	
+	*nrecv = 1 + nr;
+	return EOK;
 }
 
 /* Receive a single line */
-ssize_t recv_line(receive_buffer_t *rb, char *line, size_t size)
+int recv_line(receive_buffer_t *rb, char *line, size_t size, size_t *nrecv)
 {
 	size_t written = 0;
+	size_t nr;
 	
 	while (written < size) {
@@ -288,12 +303,19 @@
 			return rc;
 		if (c == '\n') {
-			recv_discard(rb, '\r');
+			rc = recv_discard(rb, '\r', &nr);
+			if (rc != EOK)
+				return rc;
+
 			line[written++] = 0;
-			return written;
+			*nrecv = written;
+			return EOK;
 		}
 		else if (c == '\r') {
-			recv_discard(rb, '\n');
+			rc = recv_discard(rb, '\n', &nr);
+			if (rc != EOK)
+				return rc;
 			line[written++] = 0;
-			return written;
+			*nrecv = written;
+			return EOK;
 		}
 		line[written++] = c;
Index: uspace/lib/http/src/response.c
===================================================================
--- uspace/lib/http/src/response.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/http/src/response.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -96,8 +96,9 @@
 static int expect(receive_buffer_t *rb, const char *expect)
 {
-	int rc = recv_discard_str(rb, expect);
-	if (rc < 0)
-		return rc;
-	if ((size_t) rc < str_length(expect))
+	size_t ndisc;
+	int rc = recv_discard_str(rb, expect, &ndisc);
+	if (rc != EOK)
+		return rc;
+	if (ndisc < str_length(expect))
 		return HTTP_EPARSE;
 	return EOK;
@@ -168,8 +169,9 @@
 	recv_unmark(rb, &msg_end);
 	
-	rc = recv_eol(rb);
-	if (rc == 0)
+	size_t nrecv;
+	rc = recv_eol(rb, &nrecv);
+	if (rc == EOK && nrecv == 0)
 		rc = HTTP_EPARSE;
-	if (rc < 0) {
+	if (rc != EOK) {
 		free(message);
 		return rc;
@@ -204,8 +206,9 @@
 		goto error;
 	
-	rc = recv_eol(rb);
-	if (rc == 0)
+	size_t nrecv;
+	rc = recv_eol(rb, &nrecv);
+	if (rc == EOK && nrecv == 0)
 		rc = HTTP_EPARSE;
-	if (rc < 0)
+	if (rc != EOK)
 		goto error;
 	
Index: uspace/lib/pcut/include/pcut/pcut.h
===================================================================
--- uspace/lib/pcut/include/pcut/pcut.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/include/pcut/pcut.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,3 +36,17 @@
 #include <pcut/tests.h>
 
+
+/** PCUT outcome: test passed. */
+#define PCUT_OUTCOME_PASS 0
+
+/** PCUT outcome: test failed. */
+#define PCUT_OUTCOME_FAIL 1
+
+/** PCUT outcome: test failed unexpectedly. */
+#define PCUT_OUTCOME_INTERNAL_ERROR 2
+
+/** PCUT outcome: invalid invocation of the final program. */
+#define PCUT_OUTCOME_BAD_INVOCATION 3
+
+
 #endif
Index: uspace/lib/pcut/src/assert.c
===================================================================
--- uspace/lib/pcut/src/assert.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/assert.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,10 @@
  */
 
-/** We need _BSD_SOURCE because of vsnprintf() when compiling under C89. */
+/*
+ * We need _BSD_SOURCE because of vsnprintf() when compiling under C89.
+ * In newer versions of features.h, _DEFAULT_SOURCE must be defined as well.
+ */
 #define _BSD_SOURCE
+#define _DEFAULT_SOURCE
 
 #include "internal.h"
Index: uspace/lib/pcut/src/internal.h
===================================================================
--- uspace/lib/pcut/src/internal.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/internal.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -79,14 +79,4 @@
 #define PCUT_RUN_MODE_SINGLE 2
 
-/** Test outcome: test passed. */
-#define TEST_OUTCOME_PASS 1
-
-/** Test outcome: test failed. */
-#define TEST_OUTCOME_FAIL 2
-
-/** Test outcome: test failed unexpectedly. */
-#define TEST_OUTCOME_ERROR 3
-
-
 /*
  * Use sprintf_s in Windows but only with Microsoft compiler.
@@ -109,5 +99,5 @@
 int pcut_is_arg_with_number(const char *arg, const char *opt, int *value);
 
-void pcut_run_test_forking(const char *self_path, pcut_item_t *test);
+int pcut_run_test_forking(const char *self_path, pcut_item_t *test);
 int pcut_run_test_forked(pcut_item_t *test);
 int pcut_run_test_single(pcut_item_t *test);
Index: uspace/lib/pcut/src/main.c
===================================================================
--- uspace/lib/pcut/src/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -90,8 +90,11 @@
  * @param last Pointer to first item after this suite is stored here.
  * @param prog_path Path to the current binary (used in forked mode).
- */
-static void run_suite(pcut_item_t *suite, pcut_item_t **last, const char *prog_path) {
+ * @return Error code.
+ */
+static int run_suite(pcut_item_t *suite, pcut_item_t **last, const char *prog_path) {
 	int is_first_test = 1;
 	int total_count = 0;
+	int ret_code = PCUT_OUTCOME_PASS;
+	int ret_code_tmp;
 
 	pcut_item_t *it = pcut_get_real_next(suite);
@@ -114,8 +117,19 @@
 
 		if (pcut_run_mode == PCUT_RUN_MODE_FORKING) {
-			pcut_run_test_forking(prog_path, it);
+			ret_code_tmp = pcut_run_test_forking(prog_path, it);
 		} else {
-			pcut_run_test_single(it);
-		}
+			ret_code_tmp = pcut_run_test_single(it);
+		}
+
+		/*
+		 * Override final return code in case of failure.
+		 *
+		 * In this case we suppress any special error codes as
+		 * to the outside, there was a failure.
+		 */
+		if (ret_code_tmp != PCUT_OUTCOME_PASS) {
+			ret_code = PCUT_OUTCOME_FAIL;
+		}
+
 		total_count++;
 	}
@@ -130,4 +144,6 @@
 		*last = it;
 	}
+
+	return ret_code;
 }
 
@@ -181,4 +197,6 @@
 	int run_only_test = -1;
 
+	int rc, rc_tmp;
+
 	if (main_extras == NULL) {
 		main_extras = empty_main_extra;
@@ -203,5 +221,5 @@
 			if (pcut_str_equals(argv[i], "-l")) {
 				pcut_print_tests(items);
-				return 0;
+				return PCUT_OUTCOME_PASS;
 			}
 			if (pcut_str_equals(argv[i], "-x")) {
@@ -229,5 +247,5 @@
 	if ((run_only_suite >= 0) && (run_only_test >= 0)) {
 		printf("Specify either -s or -t!\n");
-		return 1;
+		return PCUT_OUTCOME_BAD_INVOCATION;
 	}
 
@@ -236,25 +254,24 @@
 		if (suite == NULL) {
 			printf("Suite not found, aborting!\n");
-			return 2;
+			return PCUT_OUTCOME_BAD_INVOCATION;
 		}
 		if (suite->kind != PCUT_KIND_TESTSUITE) {
 			printf("Invalid suite id!\n");
-			return 3;
+			return PCUT_OUTCOME_BAD_INVOCATION;
 		}
 
 		run_suite(suite, NULL, argv[0]);
-		return 0;
+		return PCUT_OUTCOME_PASS;
 	}
 
 	if (run_only_test > 0) {
-		int rc;
 		pcut_item_t *test = pcut_find_by_id(items, run_only_test);
 		if (test == NULL) {
 			printf("Test not found, aborting!\n");
-			return 2;
+			return PCUT_OUTCOME_BAD_INVOCATION;
 		}
 		if (test->kind != PCUT_KIND_TEST) {
 			printf("Invalid test id!\n");
-			return 3;
+			return PCUT_OUTCOME_BAD_INVOCATION;
 		}
 
@@ -271,9 +288,14 @@
 	pcut_report_init(items);
 
+	rc = PCUT_OUTCOME_PASS;
+
 	it = items;
 	while (it != NULL) {
 		if (it->kind == PCUT_KIND_TESTSUITE) {
 			pcut_item_t *tmp;
-			run_suite(it, &tmp, argv[0]);
+			rc_tmp = run_suite(it, &tmp, argv[0]);
+			if (rc_tmp != PCUT_OUTCOME_PASS) {
+				rc = rc_tmp;
+			}
 			it = tmp;
 		} else {
@@ -284,4 +306,4 @@
 	pcut_report_done();
 
-	return 0;
-}
+	return rc;
+}
Index: uspace/lib/pcut/src/os/generic.c
===================================================================
--- uspace/lib/pcut/src/os/generic.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/os/generic.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,4 +34,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <sys/types.h>
 #include <errno.h>
 #include <assert.h>
@@ -94,9 +95,9 @@
 static int convert_wait_status_to_outcome(int status) {
 	if (status < 0) {
-		return TEST_OUTCOME_ERROR;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	} else if (status == 0) {
-		return TEST_OUTCOME_PASS;
+		return PCUT_OUTCOME_PASS;
 	} else {
-		return TEST_OUTCOME_FAIL;
+		return PCUT_OUTCOME_FAIL;
 	}
 }
@@ -107,6 +108,6 @@
  * @param test Test to be run.
  */
-void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
-	int rc;
+int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+	int rc, outcome;
 	FILE *tempfile;
 	char tempfile_name[PCUT_TEMP_FILENAME_BUFFER_SIZE];
@@ -126,17 +127,19 @@
 	PCUT_DEBUG("system() returned 0x%04X", rc);
 
-	rc = convert_wait_status_to_outcome(rc);
+	outcome = convert_wait_status_to_outcome(rc);
 
 	tempfile = fopen(tempfile_name, "rb");
 	if (tempfile == NULL) {
 		pcut_report_test_done(test, TEST_OUTCOME_ERROR, "Failed to open temporary file.", NULL, NULL);
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
 	fread(extra_output_buffer, 1, OUTPUT_BUFFER_SIZE, tempfile);
 	fclose(tempfile);
-	unlink(tempfile_name);
+	remove(tempfile_name);
 
-	pcut_report_test_done_unparsed(test, rc, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+
+	return outcome;
 }
 
Index: uspace/lib/pcut/src/os/helenos.c
===================================================================
--- uspace/lib/pcut/src/os/helenos.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/os/helenos.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -154,13 +154,14 @@
  * @param test Test to be run.
  */
-void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	before_test_start(test);
 
 	char tempfile_name[PCUT_TEMP_FILENAME_BUFFER_SIZE];
 	snprintf(tempfile_name, PCUT_TEMP_FILENAME_BUFFER_SIZE - 1, "pcut_%lld.tmp", (unsigned long long) task_get_id());
-	int tempfile = vfs_lookup_open(tempfile_name, WALK_REGULAR | WALK_MAY_CREATE, MODE_READ | MODE_WRITE);
-	if (tempfile < 0) {
-		pcut_report_test_done(test, TEST_OUTCOME_ERROR, "Failed to create temporary file.", NULL, NULL);
-		return;
+	int tempfile;
+	int rc = vfs_lookup_open(tempfile_name, WALK_REGULAR | WALK_MAY_CREATE, MODE_READ | MODE_WRITE, &tempfile);
+	if (rc != EOK) {
+		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, "Failed to create temporary file.", NULL, NULL);
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -174,11 +175,11 @@
 	};
 
-	int status = TEST_OUTCOME_PASS;
+	int status = PCUT_OUTCOME_PASS;
 
 	task_wait_t test_task_wait;
-	int rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments,
+	rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments,
 	    fileno(stdin), tempfile, tempfile);
 	if (rc != EOK) {
-		status = TEST_OUTCOME_ERROR;
+		status = PCUT_OUTCOME_INTERNAL_ERROR;
 		goto leave_close_tempfile;
 	}
@@ -198,11 +199,11 @@
 	rc = task_wait(&test_task_wait, &task_exit, &task_retval);
 	if (rc != EOK) {
-		status = TEST_OUTCOME_ERROR;
+		status = PCUT_OUTCOME_INTERNAL_ERROR;
 		goto leave_close_tempfile;
 	}
 	if (task_exit == TASK_EXIT_UNEXPECTED) {
-		status = TEST_OUTCOME_ERROR;
+		status = PCUT_OUTCOME_INTERNAL_ERROR;
 	} else {
-		status = task_retval == 0 ? TEST_OUTCOME_PASS : TEST_OUTCOME_FAIL;
+		status = task_retval == 0 ? PCUT_OUTCOME_PASS : PCUT_OUTCOME_FAIL;
 	}
 
@@ -213,5 +214,6 @@
 
 	aoff64_t pos = 0;
-	vfs_read(tempfile, &pos, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+	size_t nread;
+	vfs_read(tempfile, &pos, extra_output_buffer, OUTPUT_BUFFER_SIZE, &nread);
 
 leave_close_tempfile:
@@ -220,4 +222,6 @@
 
 	pcut_report_test_done_unparsed(test, status, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+
+	return status;
 }
 
Index: uspace/lib/pcut/src/os/unix.c
===================================================================
--- uspace/lib/pcut/src/os/unix.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/os/unix.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,7 +36,11 @@
 /** We need _BSD_SOURCE because of snprintf() when compiling under C89. */
 #define _BSD_SOURCE
+
+/** Newer versions of features.h needs _DEFAULT_SOURCE. */
+#define _DEFAULT_SOURCE
+
 #include <stdlib.h>
 #include <unistd.h>
-#include <stddef.h>
+#include <sys/types.h>
 #include <signal.h>
 #include <errno.h>
@@ -120,12 +124,12 @@
 	if (WIFEXITED(status)) {
 		if (WEXITSTATUS(status) != 0) {
-			return TEST_OUTCOME_FAIL;
+			return PCUT_OUTCOME_FAIL;
 		} else {
-			return TEST_OUTCOME_PASS;
+			return PCUT_OUTCOME_PASS;
 		}
 	}
 
 	if (WIFSIGNALED(status)) {
-		return TEST_OUTCOME_ERROR;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -138,7 +142,7 @@
  * @param test Test to be run.
  */
-void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	int link_stdout[2], link_stderr[2];
-	int rc, status;
+	int rc, status, outcome;
 	size_t stderr_size;
 
@@ -152,6 +156,6 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 				"pipe() failed: %s.", strerror(rc));
-		pcut_report_test_done(test, TEST_OUTCOME_ERROR, error_message_buffer, NULL, NULL);
-		return;
+		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, error_message_buffer, NULL, NULL);
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	rc = pipe(link_stderr);
@@ -159,6 +163,6 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 				"pipe() failed: %s.", strerror(rc));
-		pcut_report_test_done(test, TEST_OUTCOME_ERROR, error_message_buffer, NULL, NULL);
-		return;
+		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, error_message_buffer, NULL, NULL);
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -167,5 +171,5 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 			"fork() failed: %s.", strerror(rc));
-		rc = TEST_OUTCOME_ERROR;
+		outcome = PCUT_OUTCOME_INTERNAL_ERROR;
 		goto leave_close_pipes;
 	}
@@ -178,7 +182,7 @@
 		close(link_stderr[0]);
 
-		rc = pcut_run_test_forked(test);
-
-		exit(rc);
+		outcome = pcut_run_test_forked(test);
+
+		exit(outcome);
 	}
 
@@ -195,5 +199,5 @@
 	alarm(0);
 
-	rc = convert_wait_status_to_outcome(status);
+	outcome = convert_wait_status_to_outcome(status);
 
 	goto leave_close_parent_pipe;
@@ -206,5 +210,7 @@
 	close(link_stderr[0]);
 
-	pcut_report_test_done_unparsed(test, rc, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+
+	return outcome;
 }
 
Index: uspace/lib/pcut/src/os/windows.c
===================================================================
--- uspace/lib/pcut/src/os/windows.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/os/windows.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -144,5 +144,5 @@
  * @param test Test to be run.
  */
-void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	/* TODO: clean-up if something goes wrong "in the middle" */
 	BOOL okay = FALSE;
@@ -173,10 +173,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stdout */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	okay = SetHandleInformation(link_stdout[0], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stdout */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -185,10 +185,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stderr */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	okay = SetHandleInformation(link_stderr[0], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stderr */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -197,10 +197,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stdin */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	okay = SetHandleInformation(link_stdin[1], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stdin */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -224,5 +224,5 @@
 	if (!okay) {
 		report_func_fail(test, "CreateProcess()");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -236,15 +236,15 @@
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stdout */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	okay = CloseHandle(link_stderr[1]);
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stderr */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 	okay = CloseHandle(link_stdin[0]);
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stdin */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -267,5 +267,5 @@
 	if (test_output_thread_reader == NULL) {
 		report_func_fail(test, "CreateThread(/* read test stdout */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -281,5 +281,5 @@
 		if (!okay) {
 			report_func_fail(test, "TerminateProcess(/* PROCESS_INFORMATION.hProcess */)");
-			return;
+			return PCUT_ERROR_INTERNAL_FAILURE;
 		}
 		rc = WaitForSingleObject(process_info.hProcess, INFINITE);
@@ -287,5 +287,5 @@
 	if (rc != WAIT_OBJECT_0) {
 		report_func_fail(test, "WaitForSingleObject(/* PROCESS_INFORMATION.hProcess */)");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -294,13 +294,13 @@
 	if (!okay) {
 		report_func_fail(test, "GetExitCodeProcess()");
-		return;
+		return PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
 	if (rc == 0) {
-		outcome = TEST_OUTCOME_PASS;
+		outcome = PCUT_OUTCOME_PASS;
 	} else if ((rc > 0) && (rc < 10) && !timed_out) {
-		outcome = TEST_OUTCOME_FAIL;
+		outcome = PCUT_OUTCOME_FAIL;
 	} else {
-		outcome = TEST_OUTCOME_ERROR;
+		outcome = PCUT_OUTCOME_INTERNAL_ERROR;
 	}
 
@@ -309,8 +309,10 @@
 	if (rc != WAIT_OBJECT_0) {
 		report_func_fail(test, "WaitForSingleObject(/* stdout reader thread */)");
-		return;
+		return PCUT_ERROR_INTERNAL_FAILURE;
 	}
 
 	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+
+	return outcome;
 }
 
Index: uspace/lib/pcut/src/print.c
===================================================================
--- uspace/lib/pcut/src/print.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/print.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -81,4 +81,8 @@
 			printf("    Test `%s' [%d]\n", it->name, it->id);
 			break;
+		case PCUT_KIND_SETUP:
+		case PCUT_KIND_TEARDOWN:
+			/* Fall-through, do nothing. */
+			break;
 		default:
 			assert(0 && "unreachable case in item-kind switch");
Index: uspace/lib/pcut/src/report/tap.c
===================================================================
--- uspace/lib/pcut/src/report/tap.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/report/tap.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,4 +42,7 @@
 static int test_counter;
 
+/** Counter of all failures. */
+static int failed_test_counter;
+
 /** Counter for tests in a current suite. */
 static int tests_in_suite;
@@ -55,4 +58,5 @@
 	int tests_total = pcut_count_tests(all_items);
 	test_counter = 0;
+	failed_test_counter = 0;
 
 	printf("1..%d\n", tests_total);
@@ -75,6 +79,11 @@
  */
 static void tap_suite_done(pcut_item_t *suite) {
-	printf("#> Finished suite %s (failed %d of %d).\n",
-			suite->name, failed_tests_in_suite, tests_in_suite);
+	if (failed_tests_in_suite == 0) {
+		printf("#> Finished suite %s (passed).\n",
+				suite->name);
+	} else {
+		printf("#> Finished suite %s (failed %d of %d).\n",
+				suite->name, failed_tests_in_suite, tests_in_suite);
+	}
 }
 
@@ -129,23 +138,21 @@
 	const char *fail_error_str = NULL;
 
-	if (outcome != TEST_OUTCOME_PASS) {
+	if (outcome != PCUT_OUTCOME_PASS) {
 		failed_tests_in_suite++;
+		failed_test_counter++;
 	}
 
 	switch (outcome) {
-	case TEST_OUTCOME_PASS:
+	case PCUT_OUTCOME_PASS:
 		status_str = "ok";
 		fail_error_str = "";
 		break;
-	case TEST_OUTCOME_FAIL:
+	case PCUT_OUTCOME_FAIL:
 		status_str = "not ok";
 		fail_error_str = " failed";
 		break;
-	case TEST_OUTCOME_ERROR:
+	default:
 		status_str = "not ok";
 		fail_error_str = " aborted";
-		break;
-	default:
-		/* Shall not get here. */
 		break;
 	}
@@ -160,4 +167,9 @@
 /** Report testing done. */
 static void tap_done(void) {
+	if (failed_test_counter == 0) {
+		printf("#> Done: all tests passed.\n");
+	} else {
+		printf("#> Done: %d of %d tests failed.\n", failed_test_counter, test_counter);
+	}
 }
 
